/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

import java.util.ArrayList;
import java.util.List;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;
import org.apache.spark.sql.SparkSession;

/**
 *
 * @author pavel.contos
 */
public class PiEstimation {

	private static final String APP_NAME = "PiEstimation";

	private static final int NUMBERS = 1 << 17;
	
	private static void process(JavaSparkContext context) {
		List<Integer> listOfIndices = new ArrayList<>(PiEstimation.NUMBERS);
		for (int index = 0; index < PiEstimation.NUMBERS; index++) {
			listOfIndices.add(0);
		}

		JavaRDD<Integer> dataset = context.parallelize(listOfIndices);

		int count = dataset.map(value -> {
			double x = Math.random() * 2 - 1;
			double y = Math.random() * 2 - 1;
			return (x * x + y * y <= 1) ? 1 : 0;
		}).reduce((a, b) -> a + b);

		List<Double> list = new ArrayList<>();
		list.add(4.0 * count / PiEstimation.NUMBERS);

		JavaRDD<Double> result = context.parallelize(list);
		result.saveAsTextFile("output" + System.currentTimeMillis());
	}

	public static void main(String... args) throws Exception {
		SparkSession spark = SparkSession.builder().appName(PiEstimation.APP_NAME).getOrCreate();

		JavaSparkContext context = new JavaSparkContext(spark.sparkContext());

		PiEstimation.process(context);

		spark.stop();
	}

}
